#include <iostream>
#include <map>
#include <vector>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>

#define int __int128

using namespace std;

int maxn = 1e18;
vector<int> fib;

void initfib() {
    fib.resize(2, 1);
    while (fib[fib.size() - 1] + fib[fib.size() - 2]  <= maxn) {
        fib.push_back(fib[fib.size() - 1] + fib[fib.size() - 2]);
    }
}

signed main() {
    initfib();
    long long tc;
    cin >> tc;
    int t = tc;
    while(t--) {
        long long nc;
        cin >> nc;
        int n = nc;
        int cnt2 = 0;
        int cnt5 = 0;
        for (int i = fib.size() - 1; i >= 2; i--) {
            if (fib[i] == 8) continue;
            while (n % fib[i] == 0) {
                n /= fib[i];
                cnt2 += i == 2;
            }
        }
        if (n == 1) {
            cout << max((long long)1, (long long)cnt2 / 3 + 1) << '\n';
        } else {
            cout << 0 << '\n';
        }
    }

    return 0;
}
