#include <bits/stdc++.h>
#define int long long

using namespace std;

const int mod = 1e9 + 7;

unordered_multimap<int, int> w;

struct Count {
    map<string, int> cnt{{"aa", 0},
                         {"ab", 0},
                         {"ba", 0},
                         {"bb", 0},
                         {"ac", 0},
                         {"ca", 0},
                         {"bc", 0},
                         {"cb", 0},
                         {"cc", 0}};
    Count() = default;
    explicit Count(const string &s) {
        for (int i = 0; i < s.size() - 1; i++) {
            string curr;
            curr += s[i];
            curr += s[i + 1];
            cnt[curr]++;
        }
    }
    int& operator[](const string& i) {
        return cnt[i];
    }
    bool operator<(Count b) {
        for (const auto& i : cnt) {
            if (i.second ^ b.cnt[i.first]) return i.second < b.cnt[i.first];
        }
        return false;
    }
    bool operator==(Count b) {
        return !(*this < b || b < *this);
    }

    Count& operator-=(Count b) {
        for (auto& i : cnt) {
            i.second -= b.cnt[i.first];
        }
        return *this;
    }
    Count operator-(Count b) {
        Count copy = *this;
        return copy -= b;
    }
    Count& operator+=(Count b) {
        for (auto& i : cnt) {
            i.second += b.cnt[i.first];
        }
        return *this;
    }
    Count operator+(Count b) {
        Count copy = *this;
        return copy += b;
    }

    Count& operator-=(string b) {
        Count c(b);
        for (auto& i : cnt) {
            i.second -= c.cnt[i.first];
        }
        return *this;
    }
    Count operator-(string b) {
        Count copy = *this;
        return copy -= Count(b);
    }
    Count& operator+=(string b) {
        Count c(b);
        for (auto& i : cnt) {
            i.second += c.cnt[i.first];
        }
        return *this;
    }
    Count operator+(string b) {
        Count copy = *this;
        return copy += Count(b);
    }

    bool isZero() {
        for (const auto& i : cnt) {
            if (i.second) return false;
        }
        return true;
    }

};

void per(const string &s, string &curr, int& cnt) {
    if (s.size() == curr.size()) {
        cnt += Count(s) == Count(curr);
        return;
    }
    for (char i = 'a'; i <= 'c'; i++) {
        curr.push_back(i);
        per(s, curr, cnt);
        curr.pop_back();
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int G;
    cin >> G;
    int q;
    cin >> q;
    while (q--) {
        string s;
        cin >> s;
        if (true) {
            int cnt = 0;
            string help = "";
            per(s, help, cnt);
            cout << cnt << '\n';
        }
    }
}